﻿/*
Device Class
20 July 2008
*/

namespace LithDX
{

class CMatrix;
class CVertexColour;
class CVertexTexture;

class CTexture;
class CSprite;

class CDevice
{
public:
	CDevice(IDirect3DDevice9* aDevice);
	~CDevice();

	D3DCOLOR GetBackgroundColour() { return mBackgroundColour; }
	void SetBackgroundColour(D3DCOLOR aBackgroundColour) { mBackgroundColour = aBackgroundColour; }
	void SetTransform(D3DTRANSFORMSTATETYPE aState, const CMatrix& aMatrix);

	CTexture* CreateTexture(int aXSize, int aYSize, const tlib::TByte* aData);
	CSprite* CreateSprite(int aXSize, int aYSize, const tlib::TByte* aData);

	void BeginFrame();
	void EndFrame();

	void TriColour(const CVertexColour& aV0, const CVertexColour& aV1,
			const CVertexColour& aV2);
	void TriTexture(const CVertexTexture& aV0, const CVertexTexture& aV1,
			const CVertexTexture& aV2, CTexture* aTexture);

	void SetSpriteViewport(int aXSize, int aYSize);
	void DrawSprite(CSprite* aSprite, int aX, int aY, double aXAlign=0, double aYAlign=0);

	IDirect3DDevice9* GetDevice() { return mDevice; }

private:
	IDirect3DDevice9 *mDevice;

	D3DCOLOR mBackgroundColour;

	tlib::TArray<CTexture*> mTextures;
	tlib::TArray<CSprite*> mSprites;

	int mSpriteViewportXSize;
	int mSpriteViewportYSize;

	const int cVertexColourFormat;
	const int cVertexTextureFormat;
};

}